/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of NodeEdgeRepulsion.xs. Do not edit this file, edit NodeEdgeRepulsion.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "NodeEdgeRepulsion.xs"
#define PERL_NO_GET_CONTEXT	/* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

/* aesthetic 'node edge repulsion' - makes node and edges spread apart */

#include "aesth.h"

typedef struct private {
    aglo_point e1p, e2p, e1e2, e2e1, e1part, e2part, e, half_force_delta;
    aglo_point delta;
    aglo_point force_delta;
    aglo_real data[1];
} *private;

declare_aesth(node_edge_repulsion);

define_setup(node_edge_repulsion) {
    private private;

    Newc(__LINE__, private, sizeof(struct private) + (10*state->dimensions-1) * sizeof(aglo_real), char, struct private);
    private->delta       = &private->data[0];
    private->force_delta = &private->data[state->dimensions];
    private->e1p	 = &private->data[state->dimensions * 2];
    private->e2p	 = &private->data[state->dimensions * 3];
    private->e1e2	 = &private->data[state->dimensions * 4];
    private->e2e1	 = &private->data[state->dimensions * 5];
    private->e1part	 = &private->data[state->dimensions * 6];
    private->e2part	 = &private->data[state->dimensions * 7];
    private->e		 = &private->data[state->dimensions * 8];
    private->half_force_delta = &private->data[state->dimensions * 9];
    return private;
}

define_cleanup(node_edge_repulsion) {
    Safefree(private);
    return;
}

/* distance from point pn to edge determined by e1n and e2n */	
static void ae_point_linesegment_distance_2(aglo_state state,
                                            aglo_gradient gradient,
                                            void *private,
                                            aglo_vertex pn, 
                                            aglo_vertex e1n, 
                                            aglo_vertex e2n) {
    aglo_unsigned d = state->dimensions;
    aglo_real dp_e2e1p, dp_e1e2p;
    aglo_point e1p  = PRIVATE->e1p;
    aglo_point e2p  = PRIVATE->e2p;
    aglo_point e1e2 = PRIVATE->e1e2;
    aglo_point e2e1 = PRIVATE->e2e1;

    aglo_point_sub(d, e1p,  state->point[pn],  state->point[e1n]);
    aglo_point_sub(d, e1e2, state->point[e2n], state->point[e1n]);
    dp_e2e1p = aglo_point_dot_product(d, e1p, e1e2);

    if (dp_e2e1p >= 0) {	/* acute */
        aglo_point_sub(d, e2p, state->point[pn], state->point[e2n]);
        aglo_point_scalar_mult(d, e2e1, -1, e1e2);
        dp_e1e2p = aglo_point_dot_product(d, e2p, e2e1);
        if (dp_e1e2p >= 0) {	/* acute */
            aglo_point delta	= PRIVATE->delta;
            aglo_point e1part	= PRIVATE->e1part;
            aglo_point e2part	= PRIVATE->e2part;
            aglo_point e		= PRIVATE->e;
            aglo_point force_delta	= PRIVATE->force_delta;
            aglo_point half_force_delta = PRIVATE->half_force_delta;
            aglo_real mag2;
	
            mag2 = aglo_point_mag2(d, e1e2);
            mag2 = fmax(mag2, 1e-8); /* avoid div by 0 */
            aglo_point_scalar_mult(d, e1part, dp_e1e2p/mag2, state->point[e1n]);
            aglo_point_scalar_mult(d, e2part, dp_e2e1p/mag2, state->point[e2n]);
            /* e is the point on e1e2 closest to p */
            aglo_point_add(d, e, e1part, e2part);
            aglo_point_sub(d, delta, state->point[pn], e); 

            mag2 = aglo_point_mag2(d, delta);
            mag2 = fmax(mag2, 1e-8); /* avoid div by 0 */

            aglo_point_scalar_mult(d, force_delta, 1/mag2, delta);
            aglo_point_scalar_mult(d, half_force_delta, 0.5, force_delta);

            aglo_point_inc(d, &gradient[pn*d],  force_delta);
            aglo_point_dec(d, &gradient[e1n*d], half_force_delta);
            aglo_point_dec(d, &gradient[e2n*d], half_force_delta);
        }
    }
    /* really should handle the case when not both acute TBF */
}

define_aesth(node_edge_repulsion) {
    aglo_unsigned i, j;
    aglo_edge_record p;
    aglo_graph graph = state->graph;

    /* i < p */
    /* j != i; j != p */
    for (j=0; j<graph->vertices; j++)
        for (i=0; i<graph->vertices; i++)
            if (i != j)
                for (p=graph->edge_table[i]; p; p=p->next)
                    if (i < p->tail && j != p->tail)
                        ae_point_linesegment_distance_2(state, gradient,
                                                        private, 
                                                        j, i, p->tail);
}

#line 123 "NodeEdgeRepulsion.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 267 "NodeEdgeRepulsion.c"

XS_EUPXS(XS_Graph__Layout__Aesthetic__Force__NodeEdgeRepulsion_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Graph__Layout__Aesthetic__Force__NodeEdgeRepulsion_new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "class");
    {
#line 119 "NodeEdgeRepulsion.xs"
    aglo_force force;
#line 278 "NodeEdgeRepulsion.c"
	SV *	RETVAL;
	const char *	class = (const char *)SvPV_nolen(ST(0))
;
#line 121 "NodeEdgeRepulsion.xs"
    New(__LINE__, force, 1, struct aglo_force);
    force->aesth_gradient = ae_node_edge_repulsion;
    force->aesth_setup	 = ae_setup_node_edge_repulsion;
    force->aesth_cleanup  = ae_cleanup_node_edge_repulsion;
    force->user_data = force->private_data = NULL;
    RETVAL = NEWSV(1, 0);
    sv_setref_pv(RETVAL, class, (void*) force);
#line 290 "NodeEdgeRepulsion.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Graph__Layout__Aesthetic__Force__NodeEdgeRepulsion); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Graph__Layout__Aesthetic__Force__NodeEdgeRepulsion)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Graph::Layout::Aesthetic::Force::NodeEdgeRepulsion::new", XS_Graph__Layout__Aesthetic__Force__NodeEdgeRepulsion_new, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

