/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of NodeLevel.xs. Do not edit this file, edit NodeLevel.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "NodeLevel.xs"
#define PERL_NO_GET_CONTEXT	/* we want efficiency */
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

/* attribute 'node level' - level of node (from root) */

#include "at_node_level.h"
#include <limits.h>

/* Temporarily abuse sorted list as array of booleans */
#define at_level_assigned	level_sorted_vertex

static aglo_signed at_node_level_tree(aglo_graph graph, aglo_vertex v) {
    aglo_edge_record p;
    aglo_signed kid_level=1;

    if (graph->at_level_assigned[v]) return graph->at_level[v];

    graph->at_level_assigned[v] = true;
    graph->at_level[v] = 0;

    for (p=graph->edge_table[v];p;p=p->next)
        if (p->forward) {
            aglo_signed k = at_node_level_tree(graph, p->tail);
            if (k < kid_level) kid_level = k;
        }

    return graph->at_level[v] = kid_level - 1;
}

static void at_contract_node_level_tree(aglo_graph graph) {
    aglo_boolean change;

    do {
        aglo_unsigned i;
        aglo_edge_record p;

        change=false;
        for (i=0; i<graph->vertices; i++) {
            aglo_signed max_p_level = -INT_MAX;
            for (p=graph->edge_table[i]; p; p=p->next)
                if (!p->forward)
                    if (max_p_level < graph->at_level[p->tail])
                        max_p_level = graph->at_level[p->tail];
            if (max_p_level == -INT_MAX) continue;
            max_p_level++;
            if (max_p_level < graph->at_level[i]) {
                graph->at_level[i] = max_p_level;
                change=true;
            }
        }
    } while (change);
}

static void at_make_node_level_lists(aglo_graph graph, aglo_signed level) {
    aglo_vertex i, vcount;
    aglo_signed levels;
    aglo_vertex **level_ptr, *vertex_ptr;

    levels = -1;
    for (i=0; i<graph->vertices; i++) {
        graph->at_level[i] -= level;
        if (graph->at_level[i] < 0) 
            croak("Vertex %"UVuf" has negative node level %"IVdf, 
                  (UV) i, (IV) graph->at_level[i]);
        if (graph->at_level[i] > levels) levels = graph->at_level[i];
    }
    levels++;

    if (graph->level2nodes) {
        Safefree(graph->level2nodes);
        graph->level2nodes = NULL;
    }
    New(__LINE__, graph->level2nodes, levels+2, aglo_vertex *);
    
    level_ptr   = graph->level2nodes;
    vertex_ptr  = graph->level_sorted_vertex;
    vcount = 0;		/* doublecheck */
    for (level = 0; vcount < graph->vertices; level++) {
        aglo_vertex tvcount = vcount;

        *level_ptr++ = vertex_ptr;
        for (i=0; i<graph->vertices; i++)
            if (graph->at_level[i] == level) {
                *vertex_ptr++ = i;
                vcount++;
            }
        if (vcount == tvcount) croak("no nodes at level %"IVdf, (IV) level);
    }
    if (level != levels) croak("Expected %"IVdf" levels, found %"IVdf, 
                               (IV) levels, (IV) level);
    *level_ptr++ = vertex_ptr;
    *level_ptr++ = vertex_ptr;
    graph->nr_levels = levels;
}

static void at_calculate_node_level(aglo_graph graph) {
    aglo_vertex i;
    aglo_signed lev;
    aglo_signed min_level = INT_MAX;

    if (graph->at_level) {
        Safefree(graph->at_level);
        graph->at_level = NULL;
    }
    if (graph->level_sorted_vertex) {
        Safefree(graph->level_sorted_vertex);
        graph->level_sorted_vertex = NULL;
    }
    New(__LINE__, graph->at_level, graph->vertices, aglo_signed);
    Newz(__LINE__, graph->level_sorted_vertex, graph->vertices, aglo_vertex);

    /* initial assignement */
    for (i=0; i<graph->vertices; i++) {
        lev = at_node_level_tree(graph, i);
        if (lev < min_level) min_level = lev;
    }

    /* contraction */
    at_contract_node_level_tree(graph);
    at_make_node_level_lists(graph, min_level);
}

void at_setup_node_level(aglo_graph graph) {
    if (!graph->done) 
        croak("Won't calculate node levels on an unfinished topology");
    if (!graph->level_sequence) {
        at_calculate_node_level(graph);
        graph->level_sequence = 1;
    }
}

#line 146 "NodeLevel.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 290 "NodeLevel.c"
#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Graph__Layout__Aesthetic__Dummy__NodeLevel); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Graph__Layout__Aesthetic__Dummy__NodeLevel)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

